from llhardware._cpp.types import DataItem

class BaseItem:
    @property
    def is_attached(self) -> bool: ...
    def detach(self) -> bool: ...
    def _on_attach(self) -> None: ...
    def _on_detach(self) -> None: ...

class CollectionItem(BaseItem):
    pass

class PeriodicUpdateItem(BaseItem):
    def _call_at(self, id: int, update_time_ns: int) -> None: ...
    def _call_soon(self, id: int) -> None: ...
    def _call_later(self, id: int, delay_ns: int) -> None: ...
    def _call_cancel(self, id: int) -> None: ...
    def _update(self, id: int, update_time_ns: int, cur_time_ns: int) -> int: ...

class FileUpdateItem(BaseItem):
    def _set_event_mask(self, fd: int, mask: int) -> None: ...
    def _unset_event_mask(self, fd: int) -> None: ...
    def _on_event(self, fd: int, flag: int) -> None: ...

class StreamItem(BaseItem):
    def _on_get_data(self, item: DataItem) -> None: ...
